diff --git a/tests/generic/166 b/tests/generic/166
index 9b177be..a1e4ff4 100755
--- a/tests/generic/166
+++ b/tests/generic/166
@@ -69,7 +69,11 @@ _scratch_remount
 snappy() {
 	n=0
 	while [ ! -e $testdir/finished ]; do
-		_cp_reflink $testdir/file1 $testdir/snap_$n || break
+		out="$(_cp_reflink $testdir/file1 $testdir/snap_$n 2>&1)"
+		res=$?
+		echo "$out" | grep -q "No space left" && break
+		test -n "$out" && echo "$out"
+		test $res -ne 0 && break
 		n=$((n + 1))
 	done
 }
diff --git a/tests/generic/167 b/tests/generic/167
index ef8e75b..76969c1 100755
--- a/tests/generic/167
+++ b/tests/generic/167
@@ -68,7 +68,11 @@ _scratch_remount
 snappy() {
 	n=0
 	while [ ! -e $testdir/finished ]; do
-		_cp_reflink $testdir/file1 $testdir/snap_$n || break
+		out="$(_cp_reflink $testdir/file1 $testdir/snap_$n 2>&1)"
+		res=$?
+		echo "$out" | grep -q "No space left" && break
+		test -n "$out" && echo "$out"
+		test $res -ne 0 && break
 		n=$((n + 1))
 	done
 }
diff --git a/tests/generic/333 b/tests/generic/333
new file mode 100755
index 0000000..b8a1ea8
--- /dev/null
+++ b/tests/generic/333
@@ -0,0 +1,99 @@
+#! /bin/bash
+# FS QA Test No. 333
+#
+# Test for races or FS corruption when trying to hit ENOSPC while DIO writing
+# to a file that's also the source of a reflink operation.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2016 Oracle, Inc.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 7 15
+
+_cleanup()
+{
+    cd /
+    rm -rf $tmp.*
+    wait
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/reflink
+
+# real QA test starts here
+_supported_os Linux
+_require_scratch_reflink
+_require_cp_reflink
+_require_odirect
+
+echo "Format and mount"
+_scratch_mkfs_sized $((400 * 1048576)) > $seqres.full 2>&1
+_scratch_mount >> $seqres.full 2>&1
+
+testdir=$SCRATCH_MNT/test-$seq
+mkdir $testdir
+
+loops=1024
+nr_loops=$((loops - 1))
+blksz=65536
+
+echo "Initialize file"
+echo > $seqres.full
+_pwrite_byte 0x61 0 $((loops * blksz)) $testdir/file1 >> $seqres.full
+_scratch_remount
+
+# Snapshot creator...
+snappy() {
+	n=0
+	while [ ! -e $testdir/finished ]; do
+		out="$(_cp_reflink $testdir/file1 $testdir/snap_$n 2>&1)"
+		res=$?
+		echo $out | grep -q "No space left" && break
+		test -n "$out" && echo $out
+		test $res -ne 0 && break
+		n=$((n + 1))
+	done
+	touch $testdir/abort
+}
+
+echo "Snapshot a file undergoing directio rewrite"
+snappy &
+seq 1 1000 | while read j; do
+	seq $nr_loops -1 0 | while read i; do
+		out="$(_pwrite_byte 0x63 $((i * blksz)) $blksz -d $testdir/file1 2>&1)"
+		echo $out >> $seqres.full
+		echo $out | grep -q "No space left" && touch $testdir/abort
+		echo $out | grep -qi "error" && touch $testdir/abort
+		test -e $testdir/abort && break
+	done
+	test -e $testdir/abort && break
+done
+touch $testdir/finished
+wait
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/333.out b/tests/generic/333.out
new file mode 100644
index 0000000..3354c98
--- /dev/null
+++ b/tests/generic/333.out
@@ -0,0 +1,4 @@
+QA output created by 333
+Format and mount
+Initialize file
+Snapshot a file undergoing directio rewrite
diff --git a/tests/generic/334 b/tests/generic/334
new file mode 100755
index 0000000..89601be
--- /dev/null
+++ b/tests/generic/334
@@ -0,0 +1,98 @@
+#! /bin/bash
+# FS QA Test No. 334
+#
+# Test for races or FS corruption when trying to hit ENOSPC while writing
+# to a file that's also the source of a reflink operation.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2016 Oracle, Inc.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 7 15
+
+_cleanup()
+{
+    cd /
+    rm -rf $tmp.*
+    wait
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/reflink
+
+# real QA test starts here
+_supported_os Linux
+_require_scratch_reflink
+_require_cp_reflink
+
+echo "Format and mount"
+_scratch_mkfs_sized $((400 * 1048576)) > $seqres.full 2>&1
+_scratch_mount >> $seqres.full 2>&1
+
+testdir=$SCRATCH_MNT/test-$seq
+mkdir $testdir
+
+loops=1024
+nr_loops=$((loops - 1))
+blksz=65536
+
+echo "Initialize file"
+echo > $seqres.full
+_pwrite_byte 0x61 0 $((loops * blksz)) $testdir/file1 >> $seqres.full
+_scratch_remount
+
+# Snapshot creator...
+snappy() {
+	n=0
+	while [ ! -e $testdir/finished ]; do
+		out="$(_cp_reflink $testdir/file1 $testdir/snap_$n 2>&1)"
+		res=$?
+		echo $out | grep -q "No space left" && break
+		test -n "$out" && echo $out
+		test $res -ne 0 && break
+		n=$((n + 1))
+	done
+	touch $testdir/abort
+}
+
+echo "Snapshot a file undergoing buffered rewrite"
+snappy &
+seq 1 1000 | while read j; do
+	seq $nr_loops -1 0 | while read i; do
+		out="$(_pwrite_byte 0x63 $((i * blksz)) $blksz $testdir/file1 2>&1)"
+		echo $out >> $seqres.full
+		echo $out | grep -q "No space left" && touch $testdir/abort
+		echo $out | grep -qi "error" && touch $testdir/abort
+		test -e $testdir/abort && break
+	done
+	test -e $testdir/abort && break
+done
+touch $testdir/finished
+wait
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/334.out b/tests/generic/334.out
new file mode 100644
index 0000000..c2c40fd
--- /dev/null
+++ b/tests/generic/334.out
@@ -0,0 +1,4 @@
+QA output created by 334
+Format and mount
+Initialize file
+Snapshot a file undergoing buffered rewrite
diff --git a/tests/generic/group b/tests/generic/group
index e7ed475..e3c4e8a 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -335,3 +335,5 @@
 330 auto quick clone
 331 auto quick clone
 332 auto quick clone
+333 auto quick clone
+334 auto quick clone